=== debian/changelog ===
rnp (0.17.1-1) unstable; urgency=medium

  * New upstream version (Closes: #1064486)
  * Drop build-dep on python3-distutils (Closes: #1065948)
  * Stop shipping librnp.a, following upstream
  * Permit normal testing when gpg-from-sq is installed
  * debian/librnp0.symbols: add rnp_signature_get_features
  * move from pkg-config to pkgconf
  * fix manpage grammar

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 10 May 2024 17:15:05 -0400
